/*
ͻ
   Libreria de fuentes monocolor ->  MONOFNT.H                              
͹
  Librera grfica de tratamiento de fuentes monocolor y monotextura.       
                                                                            
  Para incluir la librera en un programa basta con aadir al listado       
  principal la orden: #include "monofnt.h" al principio del mismo.          
                                                                            
                                                                            
  Cdigo y texto: (:-> Madd <-:) de Compiler SoftWare                       
ͼ
*/

// DEFINICION DE VARIABLES 

int bucle1;
unsigned char color_sombra;              // color de sombra
unsigned int centrax , centray;          // variables de centrado


// DEFINICION DE FUNCIONES 

/*
        PutChar8x16 (     coordenada x ,
                          coordenada y ,
                          color ,
                          caracter a imprimir ,
                          direccin de la fuente ,
                          );
        Print8x16 (      coordenada x ,
                         coordenada y ,
                         color ,
                         separacin entre carcteres ,
                         con o sin sombreado ,
                         color de la sombra ,
                         especificar centrado de texto ,
                         frase ,
                         direccin de la fuente ,
                         );
             Separacion entre carcteres -> en n de pixels
             Con o sin sombreado         -> 1 con, 0 sin. En caso de llevar
                                            sombreado, especificar color en
                                            el siguiente parmetro.
             Color de la sombra.
             Centrado de texto           -> 0 no centrado, 1 centrado en modo
                                            de video 320x200, 2 contrado en
                                            un punto. En caso de estar centrado
                                            en un punto, el punto ser el
                                            marcado como parmetros.

        PutCharMonoT8x16 ( coordenada x ,
                           coordenada y ,
                           caracter ,
                           puntero de fuente monocolor,
                           puntero a textura de color ,
                           );
        PrintMonoT8x16 (   coordenada x ,
                           coordenada y ,
                           separacin entre carcteres ,
                           con o sin sombra ,
                           color de la sombra ,
                           tipo de centrado ,
                           puntero de texto a imprimir ,
                           puntero de fuente ,
                           puntero de textura
                           );


*/

void PutChar8x16 (int,int,unsigned char,unsigned char,char *);
void Print8x16 (int,int,unsigned char,char,char,unsigned char,char,char *,char *);
void PutCharMonoT8x16 (int,int,unsigned char,char *,char *);
void PrintMonoT8x16 (int,int,char,char,unsigned char,char,char *,char *, char *);


/* ==== FUENTES MONOCOLOR ================================================== */

void PutChar8x16 ( int x , int y , unsigned char color , unsigned char caracter , char *fuente )
{
int offset_inicio;
unsigned char getbyte;

offset_inicio = caracter * 16;          /* inicio del caracter escogido */

for (bucle1 = 0;bucle1 < 16;bucle1++) {
          getbyte = fuente[offset_inicio];
          if ( (getbyte & 128) > 0) PutPixel ( x , y + bucle1 , color);
          if ( (getbyte & 64)  > 0) PutPixel ( x+1 , y + bucle1 , color);
          if ( (getbyte & 32)  > 0) PutPixel ( x+2 , y + bucle1 , color);
          if ( (getbyte & 16)  > 0) PutPixel ( x+3 , y + bucle1 , color);
          if ( (getbyte & 8)   > 0) PutPixel ( x+4 , y + bucle1 , color);
          if ( (getbyte & 4)   > 0) PutPixel ( x+5 , y + bucle1 , color);
          if ( (getbyte & 2)   > 0) PutPixel ( x+6 , y + bucle1 , color);
          if ( (getbyte & 1)   > 0) PutPixel ( x+7 , y + bucle1 , color);
          offset_inicio++;
        }
}


void Print8x16 (int x ,int y ,unsigned char color ,char sep,char somb,unsigned char colsombra ,char cent,char *frase,char *fuente )
{
int long_frase;                     /* longitud de la frase en letras */
int tam_frase;                      /* longitud de la frase en pixels */
int loop;

loop = long_frase = 0;

 while (frase[long_frase++] !='\0' );

tam_frase = (long_frase * 8) + (sep*long_frase);    /* en pixels */

 if( cent == 1 )
 {
  tam_frase = tam_frase / 2;                          /* divido entre 2 */
  x = 160 - tam_frase;
 }

 if( cent==2 )
 {
   tam_frase = tam_frase / 2;                          /* divido entre 2 */
   x = x - tam_frase;
 }

 while (frase[loop] !='\0' )
  {
   if( somb )
     PutChar8x16 ( x+1 , y+1 , colsombra , frase[loop] , fuente );
     PutChar8x16 ( x , y , color , frase[loop] , fuente );
     x = x + 8 + sep;         /* separacin entre carcteres */
     loop++;            
  }
}

/* ==== FUENTES MONOTEXTURA ================================================ */

void PutCharMonoT8x16 ( int x , int y , unsigned char caracter , char *fuente , char *textura)
{
int offset_inicio ,
    off_t;
unsigned char getbyte;

offset_inicio = caracter * 16;          /* inicio del caracter escogido */
off_t = 0;

for (bucle1 = 0;bucle1 < 16;bucle1++) {
         getbyte = fuente[offset_inicio];
         if ( (getbyte & 128) > 0) PutPixel ( x , y + bucle1,textura[off_t]);
         off_t++;
         if ( (getbyte & 64)  > 0) PutPixel (x+1 ,y + bucle1,textura[off_t]);
         off_t++;
         if ( (getbyte & 32)  > 0) PutPixel (x+2 ,y + bucle1,textura[off_t]);
         off_t++;
         if ( (getbyte & 16)  > 0) PutPixel (x+3 ,y + bucle1,textura[off_t]);
         off_t++;
         if ( (getbyte & 8)   > 0) PutPixel (x+4 ,y + bucle1,textura[off_t]);
         off_t++;
         if ( (getbyte & 4)   > 0) PutPixel (x+5 ,y + bucle1,textura[off_t]);
         off_t++;
         if ( (getbyte & 2)   > 0) PutPixel (x+6 ,y + bucle1,textura[off_t]);
         off_t++;
         if ( (getbyte & 1)   > 0) PutPixel (x+7 ,y + bucle1,textura[off_t]);
         off_t++;

         offset_inicio++;
        }
}

/*------------------------------------------------------------------------ */

void PrintMonoT8x16 (int x ,int y , char sep,char somb,unsigned char colsombra ,char cent,char *frase,char *fuente , char *textura)
{
int long_frase;                     /* longitud de la frase en letras */
int tam_frase;                      /* longitud de la frase en pixels */
int loop;

loop = long_frase = 0;

 while (frase[long_frase++] !='\0' );

tam_frase = (long_frase * 8) + (sep*long_frase);    /* en pixels */

 if( cent == 1 )
 {
  tam_frase = tam_frase / 2;                          /* divido entre 2 */
  x = 160 - tam_frase;
 }

 if( cent==2 )
 {
   tam_frase = tam_frase / 2;                          /* divido entre 2 */
   x = x - tam_frase;
 }

 while (frase[loop] !='\0' )
  {
   if( somb )
     PutChar8x16 ( x+1 , y+1 , colsombra , frase[loop] , fuente );
     PutCharMonoT8x16 ( x , y , frase[loop] , fuente , textura);
     x = x + 8 + sep;         /* separacin entre carcteres */
     loop++;            
  }
}


